



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>洛谷P2014   TYVJ1051 选课</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">洛谷P2014   TYVJ1051 选课</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-29 05:44:40 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>题目描述</h2>
<p>在大学里每个学生，为了达到一定的学分，必须从很多课程里选择一些课程来学习，在课程里有些课程必须在某些课程之前学习，如高等数学总是在其它课程之前学习。现在有N门功课，每门课有个学分，每门课有一门或没有直接先修课（若课程a是课程b的先修课即只有学完了课程a，才能学习课程b）。一个学生要从这些课程里选择M门课程学习，问他能获得的最大学分是多少？</p>
<h2>输入输出格式</h2>
<p>输入格式：</p>
<p>第一行有两个整数N,M用空格隔开。(1&lt;=N&lt;=200,1&lt;=M&lt;=150)</p>
<p>接下来的N行,第I+1行包含两个整数ki和si, ki表示第I门课的直接先修课，si表示第I门课的学分。若ki=0表示没有直接先修课（1&lt;=ki&lt;=N, 1&lt;=si&lt;=20）。</p>
<p>输出格式：</p>
<p>只有一行，选M门课程的最大得分。</p>
<h2>输入输出样例</h2>
<div>
<div>输入样例#1：</p>
<pre class="prettyprint linenums">7  4<br />
2  2<br />
0  1<br />
0  4<br />
2  1<br />
7  1<br />
7  6<br />
2  2
</pre>
</div>
<div>输出样例#1：</p>
<pre class="prettyprint linenums">13</pre>
</div>
</div>
<p>树形DP 分组背包思想</p>
<p>f[i][j]表示第i门课程，包括其自身在内选j门子课程的最大收益</p>
<p>另加一维k表示子课程选了多少门，可得出f[i][j]=max(f[i][j], f[i][j-k]+f[(i的子结点v)][k] &nbsp; &nbsp; &nbsp; k&isin;[0,j) (不能取k=j，因为至少有一门是先修课v）</p>
<p>j倒序循环（分组背包思想）</p>
<p>代码如下：</p>
<div>
<pre class="prettyprint linenums"> /*by SilverN*/<br />
 #include&lt;iostream&gt;<br />
 #include&lt;algorithm&gt;<br />
 #include&lt;cstring&gt;<br />
 #include&lt;cstdio&gt;<br />
 #include&lt;cmath&gt;<br />
 #include&lt;vector&gt;<br />
 using namespace std;<br />
 const int mxn=;<br />
 int n,m;<br />
 vector&lt;int&gt;e[mxn];<br />
 int sc[mxn];<br />
 int f[mxn][mxn];//[课程序号][本层选课数]<br />
 void add_edge(int u,int v){<br />
     e[v].push_back(u);<br />
     return;<br />
 }<br />
 void dp(int x){<br />
     for(int i=;i&lt;=m;i++)f[x][i]=sc[x];<br />
     for(int i=;i&lt;e[x].size();i++){<br />
         int v=e[x][i];<br />
         dp(v);<br />
         for(int j=m;j;j--){//选j门课<br />
             for(int k=;k&lt;j;k++){<br />
                 f[x][j]=max(f[x][j],f[x][j-k]+f[v][k]);<br />
             }<br />
         }<br />
     }<br />
     return;<br />
 }<br />
 int main(){<br />
     scanf("%d%d",&amp;n,&amp;m);<br />
     int i,j;<br />
     int s,k;<br />
     for(i=;i&lt;=n;i++){<br />
         scanf("%d%d",&amp;k,&amp;sc[i]);<br />
         add_edge(i,k);<br />
     }<br />
     m++;//虚拟根节点占用一个位置<br />
     dp();<br />
     printf("%d\n",f[][m]);<br />
     return ;<br />
 }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kpy3j9.html">canvas图片处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ko7zjq.html">备忘：spring jdbc事务代码 mybatis&comma; nhibernate</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j674lq.html">NoSQL-Redis【2】-实现分布式Session</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q75lje9.html">关于yaha中文分词（将中文分词后，结合TfidfVectorizer变成向量）</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q74vxjq.html">《数学之美》（吴军 著）读书笔记：第1章 文字和语言 vs 数字和信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yp020q.html">【转载】ITU-RBT&period;656视频标准接口</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0m5owq.html">&lbrack;Android Training视频系列&rsqb; 8&period;2 Managing Audio Focus</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj53exq.html">ubuntu auto mount自动挂载硬盘</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxke41d8.html">Python中的日期和时间</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kdrg09.html">AspNet Core Api Restful &plus;Swagger  实现微服务之旅 （三）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z5zm59.html">Java语法基础（1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp7o759.html">Win7环境 搭建IIS环境。发布asp&period;net MVC项目到IIS（第二期）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yzkmw8.html">git 学习&lpar;4&rpar; ----- git rebase</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jpx2o8.html">Python IDLE配置清屏快捷键（Ctrl&plus;L）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e40p2m9.html">jQuery  preventDefault&lpar;&rpar; &comma;stopPropagation&lpar;&rpar;&comma;stopImmediatePropagation&lpar;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwg5nk8.html">JavaScript 声明提前机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j6kv5q.html">Perfect hashing &lpar;And Minimal perfect hashing&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rzd5n9.html">win 2012 安装mysql 5&period;7&period;20 及报错 This application requires Visual Studio 2013 Redistributable&period; Please install the Redistributable then run this installer again 的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4py063q.html">使用IDEA搭建spring</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnn5gnxq.html">ubuntu16安装mysql图形界面</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9p0d0kq.html">unix文件操作函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m32w09.html">富有表现力的javascript</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q76e3j8.html">RDLC直接打印帮助类</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdn5px9.html">linux vmstat 系统结果说明</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxpl5z9.html">微软职位内部推荐-Software Development Engineering II</a>
			</li>
						<li><a href="https://www.batexi.com/a/390zj2mq.html">&lbrack;转&rsqb;SQLServer跨服务器访问数据库&lpar;openrowset&sol;opendatasource&sol;openquery&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q76l618.html">EasyUI Tree判断节点是否是叶</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn75l38.html">GridView自定义删除操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q76gxk8.html">chrome扩展</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8ky2v39.html">IOS开发之&mdash;&mdash;登录加密也许用到的，反转字符串</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
